// $Id: AppShutdown.h 76591 2007-01-25 18:17:52Z elliott_c $
#ifndef APP_SHUTDOWN_H
#define APP_SHUTDOWN_H

#include "CSD_TP_Test_Export.h"
#include "OrbShutdownTask.h"
#include "tao/ORB.h"

class CSD_TP_Test_Export AppShutdown
{
  public:

    AppShutdown();
    virtual ~AppShutdown();

    void init(CORBA::ORB_ptr orb,
              unsigned num_clients);

    void wait ();

    void client_done();

    static AppShutdown* instance ();

  private:

    typedef ACE_SYNCH_MUTEX LockType;
    typedef ACE_Guard<LockType> GuardType;

    LockType lock_;
    CORBA::ORB_var orb_;
    unsigned num_clients_;
    unsigned num_clients_shutdown_;

    OrbShutdownTask orb_shutdown_task_;
};


#define TheAppShutdown AppShutdown::instance()

#endif
